from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.MyNetwork.config import PROJECTNAME, GLOBALS


def addToFactoryTool(self, out):
     print >> out, 'portal_factory modifications started.'
     
     ftool = getToolByName(self, 'portal_factory')
     
     if ftool:
          portal_factory_types = ftool.getFactoryTypes().keys()
               
     for portalType in [ typeDict['portal_type'] for typeDict in listTypes(PROJECTNAME) ]:
          if portalType not in portal_factory_types:
               portal_factory_types.append(portalType)
               ftool.manage_setPortalFactoryTypes(listOfTypeIds=portal_factory_types)
               print >> out, '    %s now uses portal_factory' % portalType
                    
     print >> out, 'portal_factory modifications done.'


def install(self):
     """Install content types, enable the portal factory"""

     out = StringIO()

     print >> out, "Installing %s" % PROJECTNAME

     # Install types
     classes = listTypes(PROJECTNAME)
     installTypes(self, out,
                  classes,
                  PROJECTNAME)
     print >> out, "Installed types"

     
     # install subskin (in the skins dir?)
     install_subskin(self, out, GLOBALS)
     print >> out, "installed subskin"

     addToFactoryTool(self, out)     
   
     
               
     #Register types with portal_factory
     #(only needed to work around the possibility that users create
     #blank instances of content types)
     #factory = getToolByName(self, 'portal_factory')
     #types = factory.getFactoryTypes().keys()
     #if PROJECTNAME not in types:
     #    types.append(PROJECTNAME)
     #print >> out, "Added %s to portal_factory" % PROJECTNAME

     #print >> out, "Added %s to portal_factory" % PROJECTNAME

   
     # return log-string
     return out.getvalue()
