from Products.Archetypes.public import BaseFolderSchema, Schema
from Products.Archetypes.public import StringField
from Products.Archetypes.public import BaseFolder, registerType
from Products.Archetypes.atapi import *
from Products.MyNetwork.config import PROJECTNAME

from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget


class NetworkFolder(BaseFolder):
    "A folder to put nodes and edges in."
    
    schema = BaseSchema.copy() +  Schema(())    
    allowed_content_types = ('node', 'edge')
    filter_content_types = 1
    _at_rename_after_creation = True

    def edges(self):
        "Get edges contained in this folder."
        output = list()

        for item in self.listFolderContents():
            if isinstance(item, edge):
                if item.getNode_a() != None and item.getNode_b() != None:
                    output.append(item)

        output.sort()
        output.reverse()
        return output


    def nodes(self):
        "Get nodes contained in this folder."
        output = list()

        for item in self.listFolderContents():
            if isinstance(item, node):
                output.append(item)

        output.sort()
        output.reverse()
        return output
    
registerType(NetworkFolder, PROJECTNAME)


class node(BaseContent):
    """An Archetype for nodes (only allowed in a network folder)"""
    schema = BaseSchema.copy() + Schema(())    
    _at_rename_after_creation = True
    global_allow = 0

registerType(node, PROJECTNAME)


class edge(BaseContent):
    """An Archetype for edges"""
    
    # Schema definition
    schema = BaseSchema.copy() + Schema((
        
        ReferenceField('node_a',
                       widget=ReferenceBrowserWidget(
                           label="start node",
                           destination=".",
                           destination_types=("node",),
                           ),
                       required = 1,
                       relationship='start',
                       allowed_types= ("node",),
                       ),

        ReferenceField('node_b',
                       widget=ReferenceBrowserWidget(
                           label="end node",
                           destination=".",
                           destination_types=("node",),
                           ),
                       required = 1,
                       relationship='end',
                       allowed_types= ("node",),
                       ),
        ))

    global_allow = 0
    _at_rename_after_creation = True
    
registerType(edge, PROJECTNAME)
